' Data saving and backlight control
'
CON
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000
  i2cSCL        = 28
  i2cSDA        = 29 
  
  EEPROM_Addr   = %1010_0100
  highpage      = %1010_0110 
  lraddr=0
  backlight=22
OBJ
i2c:"i2cobjectmod2"
Var
long stack[40]
long temp[5]
PUB Start (data,adc)
'
cognew(memory(data,adc),@stack)


pub memory (data,adc)|ins,count,dacx,c,sample,crc
  ctra:=%0_00001_000_00000000_000000_000_000000
  frqa:=1
  i2c.Init(i2cSDA, i2cSCL)
  dira[22]~~
  ins:=adc+10
  count:=adc+16
  dacx:=adc+20
  repeat

          
    if phsa>80_000_000
        phsa:=0
        !outa[22]
        longmove(@temp,data,4)
        crc:=compcrc(@temp,16)'compute crc for save checksum
        repeat until not lockset(1) 'lock i2c
        i2c.writePage(eeprom_addr, lraddr,8,@temp, 4,4)
        i2c.writeLocation(eeprom_addr, 255, crc, 8)
        i2c.writePage(highpage, lraddr,8,@temp, 4,4) 
        i2c.writeLocation(highpage, 255, crc, 8)  
        lockclr(1)        
  
    c:=long[count]
    repeat 150
      repeat while c==long[count]
      sample += word[ins]
      c++
    sample /=150 <#2500 'shaved to 12.5 volts

    if sample=>200  'if over 1 volt turn on backlight
        long[dacx]:=long[data][backlight]*(sample/25)/100
    else
        long[dacx]:=275                       

Pub compCRC (addr,size)|i,feedback,crch,data2
crch:=0
repeat i from 0 to size-1 
  data2:=(byte[addr][i])
  repeat 8
     feedback:=(crch^data2)&1
     data2>>=1
     crch>>=1
     if feedback==1
       crch^=$8c
return crch