'*************************************************
'*     GPS raw data decoder                      *
'*  Adapted from parallax gps sx software by     *
'*  Erik Friesen  friesendrywall@agapemail.com   *
'*************************************************
'
'  from main program set up variables
'  var
' long signal,satellites,time[3],date[3],latitude[4],longitude[4],altitude,speed,heading
' GPS.start(@signal,@satellites,@time,@latitude,@longitude,@altitude,@speed,@heading)
' everything is in number format except N and S for lat and long which is "N" or "S"
CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  datapin = 2
OBJ
 serial :  "simple_serial"
Var
byte gpgga[64],gprmc[64]
long stack[50]
long rcvbuf[12],tmp1,tmp2,tmp3,tmp4,a,idx,mark

PUB Start(sig,satsp,timep,datep,latitude,longitude,Altitude,speedp,headingp )
cognew (Main(sig,satsp,timep,datep,latitude,longitude,Altitude,speedp,headingp ),@stack)
Pub Main (sig,satsptr,timeptr,dateptr,latptr,lonptr,Altptr,speedptr,headingptr ) |tr,c
   serial.init(datapin, datapin, 4800)
   long [latptr][3]:=" "
   long [lonptr][3]:=" "
   repeat
      loadarray
      signal
      long[sig]:=tmp1
      sats
      long [satsptr]:=tmp1
      time
      long [timeptr][0]:=tmp1
      long [timeptr][1]:=tmp2
      long [timeptr][2]:=tmp3
      date
      long [dateptr][1]:=tmp1
      long [dateptr][0]:=tmp2
      long [dateptr][2]:=tmp3
      lat
      long [latptr][0]:=tmp1
      long [latptr][1]:=tmp2
      long [latptr][2]:=tmp3
      long [latptr][3]:=tmp4
      lon  
      long [lonptr][0]:=tmp1
      long [lonptr][1]:=tmp2
      long [lonptr][2]:=tmp3
      long [lonptr][3]:=tmp4
      alt
      long [altptr]:=tmp1
      speed
      long [speedptr]:=tmp1
      heading
      long [headingptr]:=tmp1 
Pub Loadarray 
    repeat until serial.rx=="G"
    repeat until serial.rx=="P"
    repeat until serial.rx=="G"
    repeat until serial.rx=="G"
    repeat until serial.rx=="A"
    repeat until serial.rx==","  
    repeat a from 0 to 60
       gpgga[a]:=serial.rx  
    repeat until serial.rx=="G"
    repeat until serial.rx=="P"
    repeat until serial.rx=="R"
    repeat until serial.rx=="M"
    repeat until serial.rx=="C"
    repeat until serial.rx==","
    
    repeat a from 0 to 60
       gprmc[a]:=serial.rx   
       

pub signal
a:=0
idx:=0
   repeat a from 0 to 20
         if gprmc[a]==","
            idx++
         if idx==1
            mark:=a+1
            idx++
   tmp1:=gprmc[mark]
Pub Sats 
a:=0
idx:=0
     repeat a from 0 to 60
         if gpgga[a]==","
            idx++
         if idx==6
            mark:=a+1
            idx++
    repeat idx from 0 TO 1   ' receive string from GPS stream
        rcvBuf[idx] := gpgga[idx+mark]

    ' extract values from buffer
    rcvBuf[0] := rcvBuf[0] - "0"#>0
    rcvBuf[1] := rcvBuf[1] - "0"#>0
    tmp1 := rcvBuf[0] * 10
    tmp1 := tmp1 + rcvBuf[1] 

  
pub Time
  

    repeat idx from 0 TO 5   ' receive string from GPS stream
        rcvBuf[idx] := gprmc[idx]
    

    ' extract values from buffer
    repeat idx from 0 TO 5
        rcvBuf[idx] := rcvBuf[idx] - "0"#>0

    tmp1 := rcvBuf[0] * 10
    tmp1 := tmp1 + rcvBuf[1]

    tmp2 := rcvBuf[2] * 10
    tmp2 := tmp2 + rcvBuf[3]

    tmp3 := rcvBuf[4] * 10
    tmp3 := tmp3 + rcvBuf[5]

   

pub Date 
a:=0
idx:=0 
       ' jump to (n+1)th field
      repeat a from 0 to 63
         if gprmc[a]==","
            idx++
         if idx==8
            mark:=a+1
            idx++      
    repeat idx from 0 TO 5   ' receive string from GPS stream
        rcvBuf[idx] := gprmc[idx+mark]
    repeat idx from 0 TO 5
        rcvBuf[idx] := rcvBuf[idx] - "0"#>0

    tmp1 := rcvBuf[0] * 10
    tmp1 := tmp1 + rcvBuf[1]

    tmp2 := rcvBuf[2] * 10
    tmp2 := tmp2 + rcvBuf[3]

    tmp3 := rcvBuf[4] * 10
    tmp3 := tmp3 + rcvBuf[5]

    'tmp1        ' day
    'tmp2        ' month
    'tmp3        ' year


pub Lat   
a:=0
idx:=0   
    repeat a from 0 to 30
         if gprmc[a]==","
            idx++
         if idx==2
            mark:=a+1
            idx++
    repeat idx from 0 TO 10   ' receive string from GPS stream
      rcvBuf[idx] := gprmc[idx+mark]
    

    ' extract values from buffer
    ' degrees
    rcvBuf[0] := rcvBuf[0] - "0"#>0
    rcvBuf[1] := rcvBuf[1] - "0"#>0
    tmp1 := rcvBuf[0] * 10
    tmp1 := tmp1 + rcvBuf[1]

    ' minutes
    rcvBuf[2] := rcvBuf[2] - "0"#>0
    rcvBuf[3] := rcvBuf[3] - "0"#>0
    tmp2 := rcvBuf[2] * 10
    tmp2 := tmp2 + rcvBuf[3]

    ' fractional minutes
    tmp3 := 0
    repeat idx from 5 TO 8
      rcvBuf[idx] := rcvBuf[idx] - "0"#>0
      tmp3:= tmp3* 10 ' tmpWord = tmpWord * 10
      tmp3:= tmp3+ rcvBuf[idx] ' tmpWord = tmpWord + rcvBuf(idx)

    tmp4 := "N"                   ' default to "N"
    IF rcvBuf[10] == "S"
      tmp4 := "S"  '1
  

    'tmp1
    'tmp2
    'tmpWord[1]
    'tmpWord[0]
    'tmp3
pub Lon
a:=0
idx:=0  
    repeat a from 0 to 30
         if gprmc[a]==","
            idx++
         if idx==4
            mark:=a+1
            idx++
    repeat idx from 0 TO 11   ' receive string from GPS stream
      rcvBuf[idx] := gprmc[idx+mark] 
   

    ' extract values from buffer
    ' degrees
    tmp1 := 0
    repeat idx from 0 TO 2
      rcvBuf[idx] := rcvBuf[idx] - "0"#>0
      tmp1 := tmp1 * 10
      tmp1 := tmp1 + rcvBuf[idx]

    ' minutes
    rcvBuf[3] := rcvBuf[3] - "0"#>0
    rcvBuf[4] := rcvBuf[4] - "0"#>0
    tmp2 := rcvBuf[3] * 10
    tmp2 := tmp2 + rcvBuf[4]

    ' fractional minutes
    tmp3 := 0
    repeat idx from 6 TO 9
      rcvBuf[idx] := rcvBuf[idx] - "0"#>0
      tmp3:= tmp3 * 10 ' tmpWord = tmpWord * 10
      tmp3:= tmp3 + rcvBuf[idx] ' tmpWord = tmpWord + rcvBuf(idx)
    

    tmp4 := "E"                    ' default to "E"
    IF rcvBuf[11] == "W" 
      tmp4 := "W" '1
    

    'tmp1
   'tmp2
    'tmpWord(1)
    'tmpWord(0)
    'tmp3

    'GOTO Main
pub Alt 
a:=0
idx:=0
  
    repeat a from 0 to 63
         if gpgga[a]==","
            idx++
         if idx==8
            mark:=a+1
            idx++
    repeat idx from 0 TO 6   ' receive string from GPS stream
      rcvBuf[idx] := gpgga[idx+mark]
 

    tmp1 := 0
    repeat idx from 0 TO 6
      IF rcvBuf[idx] <> "."
        rcvBuf[idx] := rcvBuf[idx] - "0"#>0
        tmp1:=tmp1 * 10 ' tmpWord = tmpWord * 10
        tmp1:=tmp1 + rcvBuf[idx] ' tmpWord = tmpWord + rcvBuf(idx)
        if rcvbuf[idx]==","
          tmp1:=0
          return
    tmp1:=tmp1*3_2808/100000

pub speed 
a:=0
idx:=0  
    repeat a from 0 to 63
         if gprmc[a]==","
            idx++
         if idx==6
            mark:=a+1    ' command = $08
            idx++
    repeat idx from 0 TO 4   ' receive string from GPS stream
      rcvBuf[idx] := gprmc[idx+mark]

    ' extract values from buffer
    tmp1 := 0
    repeat idx from 0 TO 5
      IF rcvBuf[idx] <> "."
        rcvBuf[idx] := rcvBuf[idx] - "0"#>0
        tmp1:=tmp1 * 10 ' tmpWord = tmpWord * 10
        tmp1:=tmp1 + rcvBuf[idx] ' tmpWord = tmpWord + rcvBuf(idx)
        if rcvbuf[idx]==","
          tmp1:=0
          return
    tmp1 := tmp1*115/100
      

pub heading
 a:=0
idx:=0  
    repeat a from 0 to 63
         if gprmc[a]==","
            idx++
         if idx==7
            mark:=a+1    ' wait for $GPRMC header from GPS module
            idx++

    repeat idx from 0 TO 4   ' receive string from GPS stream
      rcvBuf[idx] := gprmc[idx+mark]

    ' extract values from buffer
    tmp1 := 0
    repeat idx from 0 TO 4
      IF rcvBuf[idx] <> "."
        rcvBuf[idx] := rcvBuf[idx] - "0"#>0
        tmp1:=tmp1 * 10 ' tmpWord = tmpWord * 10
        tmp1:=tmp1 + rcvBuf[idx] ' tmpWord = tmpWord + rcvBuf(idx)
        if rcvbuf[idx]==","
          tmp1:=0
          return         